#
# Copyright (c) 2016-2021 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
# LicenseRef-NvidiaProprietary
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited
#


class NetqModule(object):
    def __init__(self):
        self.routes = {}
        self.notifications = {}
        self.default_actions = {}

    def route(self, route_str):
        def decorator(f):
            self.routes[route_str] = f
            return f

        return decorator

    def notification(self, notification_str):
        def decorator(f):
            self.notifications[notification_str] = f
            return f

        return decorator

    def default_action(self, event_type):
        def decorator(f):
            self.default_actions[event_type] = f
            return f

        return decorator


RC_SUCCESS = 0
RC_FAIL = 1
