#
# Copyright (c) 2024 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
# LicenseRef-NvidiaProprietary
#
# NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
# property and proprietary rights in and to this material, related
# documentation and any modifications thereto. Any use, reproduction,
# disclosure or distribution of this material and related documentation
# without an express license agreement from NVIDIA CORPORATION or
# its affiliates is strictly prohibited
#
from netq_lib.orm.redisdb.models import (
    Node,
    StreamingCheckAgent
)
class NodeStub(Node):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.lastboot = 0.0
        self.sys_uptime = 0.0
        self.last_reinit = 0.0
        self.timestamp = 0.0
        self.ntp_state = ""
        self.ptp_state = False
        self.version = ""
        self.appliance_version = ""
        self.manifest_hash = ""
        self.hostname = "test1"

agents_check_json = {
    "additional_summary": {

    },
    "failed_node_set": [
        "test1"
    ],
    "rotten_node_set": [
        "test1"
    ],
    "skipped_node_set": [

    ],
    "summary": {
        "checked_cnt": 10,
        "failed_node_cnt": 1,
        "rotten_node_cnt": 1,
        "skipped_node_cnt": 0,
        "total_cnt": 11,
        "warn_node_cnt": 0
    },
    "tests": {
        "Agent Health": {
            "enabled": True,
            "errors": [
                {
                    "hostname": "test1",
                    "lastChanged": 1707657200568,
                    "msg_id": "AGENT_CHECK_EVT_NODE_ROTTEN",
                    "reason": "Agent status changed to rotten. for more information run on switch: sudo systemctl status netq-agent.service"
                }
            ],
            "passed": False,
            "suppressed_errors": 0,
            "suppressed_unverified": 0,
            "suppressed_warnings": 0,
            "unverified": [

            ],
            "warnings": [

            ]
        }
    },
    "validation": "agents",
    "warn_node_set": [

    ]
}